#include <stdlib.h>
#include <stdio.h>

unsigned MAXNAME = 26 * (1 + 26 * (1 + 26));

void genname(unsigned v)
{
  char name[4];
  unsigned i = 0;
  do name[i++] = 'a' + --v % 26; while (v /= 26);
  name[i] = '\0';
  fputs(name, stdout);
}

#define DECAY	500

void gentree(int d)
{
  static int dmax = 0;
  if (d > dmax) fprintf(stderr, "%d ", dmax = d);
  int wid = (d < 16) + rand() % 5;		// at most 5 children
  if (rand() % DECAY)		// stop 1 of DECAY times
    while (wid--)
      if (rand() & 1) {	
	genname(rand() % MAXNAME);
	fputs(" [ ", stdout); gentree(d+1); fputs("] ", stdout);
      } else { putchar (rand() & 1 ? 'i' : 'n'); putchar(' '); }
}

int main(void)
{
  gentree(0);
  return 0;
}
